package edu.prlab.tyler.iotgateway.contract.common;


import org.web3j.protocol.core.RemoteCall;
import org.web3j.tx.Contract;

import java.lang.reflect.Method;

public class QuorumContractUtil {
    private QuorumContractUtil() {
    }

    //合約呼叫函式
    public static <Return> Return call(Contract contract, String function, Object... parameters) {
        try {
            Class[] classes = new Class[parameters.length];
            for (int i = 0; i < parameters.length; i++) {
                classes[i] = parameters[i].getClass();
            }
            Method method = contract.getClass().getMethod(function, classes);
            RemoteCall<Return> remoteCall = (RemoteCall<Return>) method.invoke(contract, parameters);
            return remoteCall.send();
        } catch (Exception e) {
            //do nothing
            System.out.println("Remote call Cannot find method");
        }
        return null;
    }

    //呼叫
    public static <Return> Return call(RemoteCall<Return> remoteCall){
        try {
            return remoteCall.send();
        } catch (Exception e) {
            System.out.println("call error");
        }
        return null;
    }

    //驗證合約有效性
    public static boolean isContractValid(Contract contract) {
        return contract != null &&
                contract.getContractAddress() != null &&
                !contract.getContractAddress().isEmpty();
    }

}
